diff --git a/src/vbox/vbox_tmpl.c b/src/vbox/vbox_tmpl.c
index 3208f03..0e829e3 100644
--- a/src/vbox/vbox_tmpl.c
+++ b/src/vbox/vbox_tmpl.c
@@ -3500,7 +4029,11 @@ static int vboxDomainUndefine(virDomainPtr dom) {
             VIR_FREE(hddcname);
 
             /* Open a Session for the machine */
+#if VBOX_API_VERSION == 2002
             rc = data->vboxObj->vtbl->OpenSession(data->vboxObj, data->vboxSession, iid);
+#else
+            rc = data->vboxObj->vtbl->OpenSession(data->vboxObj, data->vboxSession, iidUtf16);
+#endif
             if (NS_SUCCEEDED(rc)) {
                 rc = data->vboxSession->vtbl->GetMachine(data->vboxSession, &machine);
                 if (NS_SUCCEEDED(rc) && machine) {
@@ -3517,13 +4050,19 @@ static int vboxDomainUndefine(virDomainPtr dom) {
             data->pFuncs->pfnUtf16Free(hddcnameUtf16);
         }
 
+#if VBOX_API_VERSION == 2002
         rc = data->vboxObj->vtbl->UnregisterMachine(data->vboxObj, iid, &machine);
         DEBUG("UUID of machine being undefined:{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
-        (unsigned)iid->m0,    (unsigned)iid->m1, (unsigned)iid->m2,
-        (unsigned)iid->m3[0], (unsigned)iid->m3[1],
-        (unsigned)iid->m3[2], (unsigned)iid->m3[3],
-        (unsigned)iid->m3[4], (unsigned)iid->m3[5],
-        (unsigned)iid->m3[6], (unsigned)iid->m3[7]);
+              (unsigned)iid->m0,    (unsigned)iid->m1,
+              (unsigned)iid->m2,    (unsigned)iid->m3[0],
+              (unsigned)iid->m3[1], (unsigned)iid->m3[2],
+              (unsigned)iid->m3[3], (unsigned)iid->m3[4],
+              (unsigned)iid->m3[5], (unsigned)iid->m3[6],
+              (unsigned)iid->m3[7]);
+#else
+        rc = data->vboxObj->vtbl->UnregisterMachine(data->vboxObj, iidUtf16, &machine);
+        DEBUG("UUID of machine being undefined: %s", iidUtf8);
+#endif
 
         if (NS_SUCCEEDED(rc) && machine){
             machine->vtbl->DeleteSettings(machine);
@@ -3531,11 +4070,15 @@ static int vboxDomainUndefine(virDomainPtr dom) {
         }
     }
 
+#if VBOX_API_VERSION == 2002
 cleanup:
+    VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     if (machine)
         machine->vtbl->nsisupports.Release((nsISupports *)machine);
 
-    VIR_FREE(iid);
     return ret;
 }
 
@@ -3543,7 +4086,12 @@ static int vboxDomainAttachDevice(virDomainPtr dom, const char *xml) {
     nsresult rc;
     vboxGlobalData *data = dom->conn->privateData;
     IMachine *machine    = NULL;
-    nsID *iid            = NULL;
+#if VBOX_API_VERSION == 2002
+    nsID  *iid           = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+#endif
     PRUint32 state       = MachineState_Null;
     virDomainDefPtr def  = NULL;
     virDomainDeviceDefPtr dev  = NULL;
@@ -3563,6 +4111,7 @@ static int vboxDomainAttachDevice(virDomainPtr dom, const char *xml) {
         goto cleanup;
     }
 
+#if VBOX_API_VERSION == 2002
     if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(dom->conn);
         goto cleanup;
@@ -3576,8 +4125,14 @@ static int vboxDomainAttachDevice(virDomainPtr dom, const char *xml) {
           (unsigned)iid->m3[3], (unsigned)iid->m3[4],
           (unsigned)iid->m3[5], (unsigned)iid->m3[6],
           (unsigned)iid->m3[7]);
+#else
+    virUUIDFormat(dom->uuid, iidUtf8);
+    data->pFuncs->pfnUtf8ToUtf16(iidUtf8, &iidUtf16);
+    DEBUG("machine uuid: %s", iidUtf8);
+#endif
 
     if(data->vboxObj) {
+#if VBOX_API_VERSION == 2002
         rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iid, &machine);
         if (NS_FAILED(rc)) {
             vboxError(dom->conn, VIR_ERR_INVALID_DOMAIN,
@@ -3591,16 +4146,34 @@ static int vboxDomainAttachDevice(virDomainPtr dom, const char *xml) {
                       (unsigned)iid->m3[7]);
             goto cleanup;
         }
+#else
+        rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iidUtf16, &machine);
+        if (NS_FAILED(rc)) {
+            vboxError(dom->conn, VIR_ERR_INVALID_DOMAIN,
+                      "no domain with matching uuid: %s",
+                      iidUtf8);
+            goto cleanup;
+        }
+#endif
 
         if (machine) {
             machine->vtbl->GetState(machine, &state);
 
+#if VBOX_API_VERSION == 2002
             if ((state == MachineState_Running) ||
                 (state == MachineState_Paused)) {
                 rc = data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iid);
             } else {
                 rc = data->vboxObj->vtbl->OpenSession(data->vboxObj, data->vboxSession, iid);
             }
+#else
+            if ((state == MachineState_Running) ||
+                (state == MachineState_Paused)) {
+                rc = data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iidUtf16);
+            } else {
+                rc = data->vboxObj->vtbl->OpenSession(data->vboxObj, data->vboxSession, iidUtf16);
+            }
+#endif
             if (NS_SUCCEEDED(rc)) {
                 rc = data->vboxSession->vtbl->GetMachine(data->vboxSession, &machine);
                 if (NS_SUCCEEDED(rc) && machine) {
@@ -3614,21 +4187,35 @@ static int vboxDomainAttachDevice(virDomainPtr dom, const char *xml) {
                                  */
                                 machine->vtbl->GetDVDDrive(machine, &dvdDrive);
                                 if (dvdDrive) {
-                                    IDVDImage *dvdImage     = NULL;
-                                    PRUnichar *dvdfileUtf16 = NULL;
-                                    nsID *dvduuid           = NULL;
+                                    IDVDImage *dvdImage          = NULL;
+                                    PRUnichar *dvdfileUtf16      = NULL;
+#if VBOX_API_VERSION == 2002
+                                    nsID *dvduuid                = NULL;
                                     nsID dvdemptyuuid;
 
                                     memset(&dvdemptyuuid, 0, sizeof(dvdemptyuuid));
+#else
+                                    char      *dvduuidUtf8       = NULL;
+                                    PRUnichar *dvduuidUtf16      = NULL;
+                                    PRUnichar *dvdemptyuuidUtf16 = NULL;
+#endif
 
                                     data->pFuncs->pfnUtf8ToUtf16(dev->data.disk->src, &dvdfileUtf16);
 
                                     data->vboxObj->vtbl->FindDVDImage(data->vboxObj, dvdfileUtf16, &dvdImage);
                                     if (!dvdImage) {
+#if VBOX_API_VERSION == 2002
                                         data->vboxObj->vtbl->OpenDVDImage(data->vboxObj, dvdfileUtf16, &dvdemptyuuid, &dvdImage);
+#else
+                                        data->vboxObj->vtbl->OpenDVDImage(data->vboxObj, dvdfileUtf16, dvdemptyuuidUtf16, &dvdImage);
+#endif
                                     }
                                     if (dvdImage) {
+#if VBOX_API_VERSION == 2002
                                         rc = dvdImage->vtbl->imedium.GetId((IMedium *)dvdImage, &dvduuid);
+#else
+                                        rc = dvdImage->vtbl->imedium.GetId((IMedium *)dvdImage, &dvduuidUtf16);
+#endif
                                         if (NS_FAILED(rc)) {
                                             vboxError(dom->conn, VIR_ERR_INTERNAL_ERROR,"%s:%s, rc=%08x",
                                                       "can't get the uuid of the file to be attached to cdrom",
@@ -3636,13 +4223,18 @@ static int vboxDomainAttachDevice(virDomainPtr dom, const char *xml) {
                                         } else {
                                             /* unmount the previous mounted image */
                                             dvdDrive->vtbl->Unmount(dvdDrive);
+#if VBOX_API_VERSION == 2002
                                             rc = dvdDrive->vtbl->MountImage(dvdDrive, dvduuid);
+#else
+                                            rc = dvdDrive->vtbl->MountImage(dvdDrive, dvduuidUtf16);
+#endif
                                             if (NS_FAILED(rc)) {
                                                 vboxError(dom->conn, VIR_ERR_INTERNAL_ERROR,"%s:%s, rc=%08x",
                                                           "could not attach the file to cdrom",
                                                           dev->data.disk->src, (unsigned)rc);
                                             } else {
                                                 ret = 0;
+#if VBOX_API_VERSION == 2002
                                                 DEBUG("CD/DVD Image UUID:"
                                                       "{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
                                                       (unsigned)dvduuid->m0,    (unsigned)dvduuid->m1,
@@ -3651,12 +4243,21 @@ static int vboxDomainAttachDevice(virDomainPtr dom, const char *xml) {
                                                       (unsigned)dvduuid->m3[3], (unsigned)dvduuid->m3[4],
                                                       (unsigned)dvduuid->m3[5], (unsigned)dvduuid->m3[6],
                                                       (unsigned)dvduuid->m3[7]);
+#else
+                                                data->pFuncs->pfnUtf16ToUtf8(dvduuidUtf16, &dvduuidUtf8);
+                                                DEBUG("CD/DVDImage UUID: %s", dvduuidUtf8);
+                                                data->pFuncs->pfnUtf8Free(dvduuidUtf8);
+#endif
                                             }
-                                            data->pFuncs->pfnComUnallocMem(dvduuid);
                                         }
 
                                         dvdImage->vtbl->imedium.nsisupports.Release((nsISupports *)dvdImage);
                                     }
+#if VBOX_API_VERSION == 2002
+                                    data->pFuncs->pfnComUnallocMem(dvduuid);
+#else
+                                    data->pFuncs->pfnUtf16Free(dvduuidUtf16);
+#endif
                                     data->pFuncs->pfnUtf16Free(dvdfileUtf16);
                                     dvdDrive->vtbl->nsisupports.Release((nsISupports *)dvdDrive);
                                 }
@@ -3669,36 +4270,57 @@ static int vboxDomainAttachDevice(virDomainPtr dom, const char *xml) {
                                 if (floppyDrive) {
                                     rc = floppyDrive->vtbl->SetEnabled(floppyDrive, 1);
                                     if (NS_SUCCEEDED(rc)) {
-                                        IFloppyImage *floppyImage = NULL;
-                                        PRUnichar *fdfileUtf16    = NULL;
-                                        nsID *fduuid              = NULL;
+                                        IFloppyImage *floppyImage   = NULL;
+                                        PRUnichar *fdfileUtf16      = NULL;
+#if VBOX_API_VERSION == 2002
+                                        nsID *fduuid                = NULL;
                                         nsID fdemptyuuid;
 
                                         memset(&fdemptyuuid, 0, sizeof(fdemptyuuid));
-
+#else
+                                        char      *fduuidUtf8       = NULL;
+                                        PRUnichar *fduuidUtf16      = NULL;
+                                        PRUnichar *fdemptyuuidUtf16 = NULL;
+#endif
                                         data->pFuncs->pfnUtf8ToUtf16(dev->data.disk->src, &fdfileUtf16);
-                                        rc = data->vboxObj->vtbl->FindFloppyImage(data->vboxObj, fdfileUtf16,
+                                        rc = data->vboxObj->vtbl->FindFloppyImage(data->vboxObj,
+                                                                                  fdfileUtf16,
                                                                                   &floppyImage);
 
                                         if (!floppyImage) {
-                                            data->vboxObj->vtbl->OpenFloppyImage(data->vboxObj, fdfileUtf16,
-                                                                                 &fdemptyuuid, &floppyImage);
+                                            data->vboxObj->vtbl->OpenFloppyImage(data->vboxObj,
+                                                                                 fdfileUtf16,
+#if VBOX_API_VERSION == 2002
+                                                                                 &fdemptyuuid,
+#else
+                                                                                 fdemptyuuidUtf16,
+#endif
+                                                                                 &floppyImage);
                                         }
 
                                         if (floppyImage) {
+#if VBOX_API_VERSION == 2002
                                             rc = floppyImage->vtbl->imedium.GetId((IMedium *)floppyImage, &fduuid);
+#else
+                                            rc = floppyImage->vtbl->imedium.GetId((IMedium *)floppyImage, &fduuidUtf16);
+#endif
                                             if (NS_FAILED(rc)) {
                                                 vboxError(dom->conn, VIR_ERR_INTERNAL_ERROR,"%s:%s, rc=%08x",
                                                           "can't get the uuid of the file to be attached to floppy drive",
                                                           dev->data.disk->src, (unsigned)rc);
                                             } else {
+#if VBOX_API_VERSION == 2002
                                                 rc = floppyDrive->vtbl->MountImage(floppyDrive, fduuid);
+#else
+                                                rc = floppyDrive->vtbl->MountImage(floppyDrive, fduuidUtf16);
+#endif
                                                 if (NS_FAILED(rc)) {
                                                     vboxError(dom->conn, VIR_ERR_INTERNAL_ERROR,"%s:%s, rc=%08x",
                                                               "could not attach the file to floppy drive",
                                                               dev->data.disk->src, (unsigned)rc);
                                                 } else {
                                                     ret = 0;
+#if VBOX_API_VERSION == 2002
                                                     DEBUG("attached floppy, UUID:"
                                                           "{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
                                                           (unsigned)fduuid->m0,    (unsigned)fduuid->m1,
@@ -3707,11 +4329,20 @@ static int vboxDomainAttachDevice(virDomainPtr dom, const char *xml) {
                                                           (unsigned)fduuid->m3[2], (unsigned)fduuid->m3[3],
                                                           (unsigned)fduuid->m3[4], (unsigned)fduuid->m3[5],
                                                           (unsigned)fduuid->m3[6], (unsigned)fduuid->m3[7]);
+#else
+                                                    data->pFuncs->pfnUtf16ToUtf8(fduuidUtf16, &fduuidUtf8);
+                                                    DEBUG("attached floppy, UUID: %s", fduuidUtf8);
+                                                    data->pFuncs->pfnUtf8Free(fduuidUtf8);
+#endif
                                                 }
-                                                data->pFuncs->pfnComUnallocMem(fduuid);
                                             }
                                             floppyImage->vtbl->imedium.nsisupports.Release((nsISupports *)floppyImage);
                                         }
+#if VBOX_API_VERSION == 2002
+                                        data->pFuncs->pfnComUnallocMem(fduuid);
+#else
+                                        data->pFuncs->pfnUtf16Free(fduuidUtf16);
+#endif
                                         data->pFuncs->pfnUtf16Free(fdfileUtf16);
                                     }
                                     floppyDrive->vtbl->nsisupports.Release((nsISupports *)floppyDrive);
@@ -3735,7 +4366,11 @@ static int vboxDomainAttachDevice(virDomainPtr dom, const char *xml) {
     }
 
 cleanup:
+#if VBOX_API_VERSION == 2002
     VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     virDomainDefFree(def);
     virDomainDeviceDefFree(dev);
     return ret;
@@ -3745,7 +4380,12 @@ static int vboxDomainDetachDevice(virDomainPtr dom, const char *xml) {
     nsresult rc;
     vboxGlobalData *data = dom->conn->privateData;
     IMachine *machine    = NULL;
-    nsID *iid            = NULL;
+#if VBOX_API_VERSION == 2002
+    nsID  *iid           = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+#endif
     PRUint32 state       = MachineState_Null;
     virDomainDefPtr def  = NULL;
     virDomainDeviceDefPtr dev  = NULL;
@@ -3765,6 +4405,7 @@ static int vboxDomainDetachDevice(virDomainPtr dom, const char *xml) {
         goto cleanup;
     }
 
+#if VBOX_API_VERSION == 2002
     if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(dom->conn);
         goto cleanup;
@@ -3778,8 +4419,14 @@ static int vboxDomainDetachDevice(virDomainPtr dom, const char *xml) {
           (unsigned)iid->m3[3], (unsigned)iid->m3[4],
           (unsigned)iid->m3[5], (unsigned)iid->m3[6],
           (unsigned)iid->m3[7]);
+#else
+    virUUIDFormat(dom->uuid, iidUtf8);
+    data->pFuncs->pfnUtf8ToUtf16(iidUtf8, &iidUtf16);
+    DEBUG("machine uuid: %s", iidUtf8);
+#endif
 
     if(data->vboxObj) {
+#if VBOX_API_VERSION == 2002
         rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iid, &machine);
         if (NS_FAILED(rc)) {
             vboxError(dom->conn, VIR_ERR_INVALID_DOMAIN,
@@ -3793,16 +4440,34 @@ static int vboxDomainDetachDevice(virDomainPtr dom, const char *xml) {
                       (unsigned)iid->m3[7]);
             goto cleanup;
         }
+#else
+        rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iidUtf16, &machine);
+        if (NS_FAILED(rc)) {
+            vboxError(dom->conn, VIR_ERR_INVALID_DOMAIN,
+                      "no domain with matching uuid: %s",
+                      iidUtf8);
+            goto cleanup;
+        }
+#endif
 
         if (machine) {
             machine->vtbl->GetState(machine, &state);
 
+#if VBOX_API_VERSION == 2002
             if ((state == MachineState_Running) ||
                 (state == MachineState_Paused)) {
                 rc = data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iid);
             } else {
                 rc = data->vboxObj->vtbl->OpenSession(data->vboxObj, data->vboxSession, iid);
             }
+#else
+            if ((state == MachineState_Running) ||
+                (state == MachineState_Paused)) {
+                rc = data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iidUtf16);
+            } else {
+                rc = data->vboxObj->vtbl->OpenSession(data->vboxObj, data->vboxSession, iidUtf16);
+            }
+#endif
             if (NS_SUCCEEDED(rc)) {
                 rc = data->vboxSession->vtbl->GetMachine(data->vboxSession, &machine);
                 if (NS_SUCCEEDED(rc) && machine) {
